/*
    Copyright (C) 2000  Andy Sherwood   (enigmax@home.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Folder.h : Declaration of the CFolder

#ifndef __Folder_H_
#define __Folder_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CFolder
class ATL_NO_VTABLE CFolder : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CFolder, &CLSID_Folder>,
	public IDispatchImpl<IFolder, &IID_IFolder, &LIBID_RIO500REMIXLib>
{
public:
	CFolder();

    DECLARE_REGISTRY_RESOURCEID(IDR_FOLDER)

    DECLARE_PROTECT_FINAL_CONSTRUCT()

    BEGIN_COM_MAP(CFolder)
	    COM_INTERFACE_ENTRY(IFolder)
	    COM_INTERFACE_ENTRY(IDispatch)
    END_COM_MAP()

 // IFolder
 public:
	STDMETHOD(get_Number)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_Number)(/*[in]*/ long newVal);
	STDMETHOD(get_Name)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Name)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Bitmap)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Bitmap)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_BitmapBlocks)(/*[out, retval]*/ WORD *pVal);
	STDMETHOD(put_BitmapBlocks)(/*[in]*/ WORD newVal);

 protected:
	long                m_lNumber;
	_bstr_t             m_bsName;
    _variant_t          m_vBitmap;
	WORD                m_wBitmapBlocks;
};

#endif //__Folder_H_
