/*
    Copyright (C) 2000  Andy Sherwood   (enigmax@home.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Song.h : Declaration of the CSong

#ifndef __Song_H_
#define __Song_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CSong
class ATL_NO_VTABLE CSong : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSong, &CLSID_Song>,
	public IDispatchImpl<ISong, &IID_ISong, &LIBID_RIO500REMIXLib>
{
public:
	CSong();

DECLARE_REGISTRY_RESOURCEID(IDR_SONG)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSong)
	COM_INTERFACE_ENTRY(ISong)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// ISong
public:
	STDMETHOD(get_Name)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_Name)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Number)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_Number)(/*[in]*/ long newVal);
	STDMETHOD(get_Bitmap)(/*[out, retval]*/ VARIANT *pVal);
	STDMETHOD(put_Bitmap)(/*[in]*/ VARIANT newVal);
	STDMETHOD(get_BitmapBlocks)(/*[out, retval]*/ WORD *pVal);
	STDMETHOD(put_BitmapBlocks)(/*[in]*/ WORD newVal);
	STDMETHOD(get_Folder)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_Folder)(/*[in]*/ long newVal);
	STDMETHOD(get_SongFileName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_SongFileName)(/*[in]*/ BSTR newVal);
	STDMETHOD(get_Size)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_Size)(/*[in]*/ long newVal);

    _bstr_t         m_bsName;
    long            m_lNumber;
    _variant_t      m_vBitmap;
    WORD            m_wBitmapBlocks;
    long            m_lFolder;
    _bstr_t         m_bsSongFileName;
    long            m_lSize;
};

#endif //__Song_H_
